package de.thpeetz.kontor.comics.views;

import java.util.List;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.grid.Grid;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.comics.data.Artist;
import de.thpeetz.kontor.comics.data.ComicWork;
import lombok.*;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class ArtistForm extends FormLayout {

    TextField name = new TextField("Name");
    TextField weblink = new TextField("Link");
    Grid<ComicWork> comicWorks = new Grid<>(ComicWork.class);

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Artist> binder = new BeanValidationBinder<>(Artist.class);

    public ArtistForm() {
        addClassName("artist-form");
        binder.bindInstanceFields(this);

        comicWorks.setColumns("workType.name", "comic.title");
        comicWorks.getColumnByKey("workType.name").setHeader("Work type");
        comicWorks.getColumnByKey("comic.title").setHeader("Comic");
        comicWorks.getColumns().forEach(col -> col.setAutoWidth(true));
        add(name, weblink, comicWorks, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setArtist(Artist artist) {
        binder.setBean(artist);
    }

    public void setComicWorks(List<ComicWork> works) {
        log.info("Setting comic works: {}", works);
        this.comicWorks.setItems(works);
    }

    @Getter
    public abstract static class ArtistFormEvent extends ComponentEvent<ArtistForm> {
        private final Artist artist;

        protected ArtistFormEvent(ArtistForm source, Artist artist) {
            super(source, false);
            this.artist = artist;
        }

    }

    public static class SaveEvent extends ArtistFormEvent {
        SaveEvent(ArtistForm source, Artist artist) {
            super(source, artist);
        }
    }

    public static class DeleteEvent extends ArtistFormEvent {
        DeleteEvent(ArtistForm source, Artist artist) {
            super(source, artist);
        }
    }

    public static class CloseEvent extends ArtistFormEvent {
        CloseEvent(ArtistForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
